'	KEYPR********************************************************
'
'	Program to get key press and put it on the screen
'
'	Programmer	: Henk Siewert / SWT Software
'	Date		: 08 October 2011
'	Program name	: KEYPR.BAS
'	Binary		: KEYPR.COM
'	Version		: 1.1
'	Operating sys.	: CP/M 2.2
'	Language	: Microsoft Basic-80 Extended, Disk
'	Compiler	: Microsoft BASCOM 5.30a
' 
'	Compiled and tested with Z80mu emulator on Windows XP Pro SP3
' 
'	Web : http://www.swtcomputer.com
' 
'	*************************************************************
'
	GOTO 0001	' You have to start somewhere...
'
'	+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
0001	' Main - start of program
'	+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' 
 	GOSUB 1000	' Define functions and program options
	GOSUB 1100 	' Declare vars
	GOSUB 1200	' Print Page Header
	GOTO 1300	' Wait for key and put on screen
' 
1000	' Define functions and program options
'	-------------------------------------------------------------
' 
	DEBUG = 0				      ' For debugging
'
1100	' Declare vars
'	-------------------------------------------------------------
	DEFINT X-Z			       'For binary conversion
	B$ = ""					      ' Binary string
	X$ = ""				         ' Dummy for INPUT(1)
	LIJN$=" "+STRING$(24,"-")			' Header line
	MAKER$="SWT Software"
	PROG$=" KEYPR"
	RETURN
'
1200	' Print Page Header
'	-------------------------------------------------------------
	PRINT
	PRINT
	PRINT LIJN$				     ' Print top line
	PRINT PROG$;" - ";MAKER$
	PRINT LIJN$			   ' Print bottom header line
	RETURN
'
1300	' Wait for key press and put on screen
'	-------------------------------------------------------------
	PRINT " ";
	X$=input$(1)
	IF ASC(X$)=27 THEN GOTO 1500
	PRINT "Key pressed = ";X$
	PRINT " ASCII code  =";ASC(X$)
	PRINT " Hex code    = ";HEX$(ASC(X$))
	PRINT " Octaal code = ";OCT$(ASC(X$))
	GOSUB 1400
	PRINT " Binary code =";B$
	PRINT
	PRINT
	GOTO 1300					 'Do it again
' 
1400	' Convert to binary
'	-------------------------------------------------------------
	B$=""
	X=ASC(X$)
	WHILE X>0
		Y=X\2
		Z=X MOD 2
		B$=STR$(Z)+B$
		X=Y
	WEND
	RETURN
' 
1500	' ESC
'	-------------------------------------------------------------
	PRINT "You pressed de ESC key. Program is terminated.
	PRINT
	END

